/************************************************************************
 * sted.h
 *
 * $Date: 2006/04/09 15:00:19 $, $Revision: 1.3 $
 *
 * sted, stehub Ȥإåե롣
 *
 *************************************************************************/ 

#ifndef __STED_H
#define __STED_H

#ifdef  STE_WINDOWS
#include "sted_win.h"
#define STEPATH "\\\\.\\STE"    /* ste ǥХΥѥ */
#else
#define STEPATH "/dev/ste"      /* ste ǥХΥѥ */
#endif

/*
 * Windows ξ SAGetLastError() Ȥä errno ˥顼ֹ򥻥åȤ
 * ޤWindows ξ socket  close ˤ closesocket() Ȥ
 */
#ifdef STE_WINDOWS
#define SET_ERRNO()   errno = WSAGetLastError()
#define CLOSE(fd)     closesocket(fd)
#else
#define SET_ERRNO()
#define CLOSE(fd)     close(fd)
#endif

/*
 * o  NIC ǡѤƼѥ᡼
 *
 *  CONNECT_REQ_SIZE     proxy Ф CONNECT ׵ʸĹ 
 *  CONNECT_REQ_TIMEOUT  Proxy  CONNECT Υ쥹ݥ󥹤륿ॢ
 *  STRBUFSIZE           getmsg(9F),putmsg(9F) ѤΥХåեΥ 
 *  PORT_NO              ǥեȤβۥϥ֤Υݡֹ
 *  SOCKBUFSIZE          recv(), send() ѤΥХåեΥ                
 *  ERR_MSG_MAX          syslog 䡢STDERR ˽ϤåΥ   
 *  SENDBUF_THRESHOLD    ХåեΥǡ뤷͡
 *  SELECT_TIMEOUT       select() ѤΥॢȡSolaris )
 *  HTTP_STAT_OK         HTTP Υơ OK
 *  MAXHOSTNAME          ۥ̾HUBProxyˤκĹ 
 *  GETMSG_MAXWAIT       getmsg(9F) Υॢ͡Solaris )
 */
#define  CONNECT_REQ_SIZE         200    
#define  CONNECT_REQ_TIMEOUT      10  
#define  STRBUFSIZE               32768       
#define  PORT_NO                  80            
#define  SOCKBUFSIZE              32768     
#define  ERR_MSG_MAX              300         
#define  SENDBUF_THRESHOLD        3028    // ETHERMAX(1514) x 2
#define  SELECT_TIMEOUT           400000  // 400m sec = 0.4 sec
#define  HTTP_STAT_OK             200        
#define  MAXHOSTNAME              30          
#define  GETMSG_MAXWAIT           15
#define  STE_MAX_DEVICE_NAME      30

/*
 *  NIC ǡ sted ȡۥϥ֥ǡ stehub ̿
 * Ԥݡ Ethernet ե졼Υǡղäإå
 */
typedef struct stehead 
{
    int           len;    /* ѥǥ󥰸Υǡ */
    int           orglen; /* ѥǥ󥰤Υ*/
} stehead_t;

/*
 * sted ǡ󤬻Ȥ sted δѹ¤
 * HUB Ȥ̿ξ䡢 NIC ɥ饤ФξäƤ롣
 */
typedef struct sted_stat
{
    /* Socket ̿Ѿ */
    int           sock_fd;                 /* HUB ޤ Proxy Ȥ̿ˤĤ FD  */
    char          hub_name[MAXHOSTNAME];   /* ۥϥ̾ */
    int           hub_port;                /* ۥϥ֤Υݡֹ */
    char          proxy_name[MAXHOSTNAME]; /* ץ̾   */ 
    int           proxy_port;              /* ץФΥݡֹ  */
    int           sendbuflen;              /* Хåեؤθߤν񤭹ߥ  */
    int           datalen;                 /* ѥåɤޤ Ethernet ե졼Υ*/
    int           orgdatalen;              /*  Ethernet ե졼Υ        */
    int           dataleft;                /* ̤ Ethernet ե졼Υ    */
    stehead_t     dummyhead;               /*  stehead Υԡ           */
    int           dummyheadlen;            /* Ѥߤ stehead Υ           */
    int           use_syslog;              /* å STDERR Ǥʤsyslog ˽Ϥ */
    unsigned char sendbuf[SOCKBUFSIZE];    /* Socket ѥХåե */
    unsigned char recvbuf[SOCKBUFSIZE];    /* Socket ѥХåե */
    /* ste ɥ饤Ѿ */
#ifdef STE_WINDOWS
    HANDLE        ste_handle;              /*  NIC ǥХ򥪡ץ󤷤եϥɥ */
#else    
    int           ste_fd;                  /*  NIC ǥХ򥪡ץ󤷤 FD */
#endif    
    unsigned char wdatabuf[STRBUFSIZE]; /* ɥ饤Фؤν񤭹ѥХåե  */
    unsigned char rdatabuf[STRBUFSIZE]; /* ɥ饤Фɤ߹ѥХåե*/    
} stedstat_t;

/*
 * sted ؿΥץȥ
 */
extern void     print_err(int, char *, ...);
extern int      open_socket(stedstat_t *, char *, char *);
extern int      read_socket(stedstat_t *);
extern int      write_socket(stedstat_t *);
extern u_char  *read_socket_header(stedstat_t *, int *, unsigned char *);
extern int      send_connect_req(stedstat_t *);
extern char    *stat2string(int);
extern void     print_usage(char *);
extern int      open_ste(stedstat_t *, char *, int);
extern int      write_ste(stedstat_t *);
extern int      read_ste(stedstat_t *);

#endif /* #ifndef __STED_H */
