/****************************************************************************
 * 2005/02/01
 * 
 * sted_socket.o
 *
 *  NIC Υ桼ץΥǡ󤬻Ȥ socket ѥ롼
 * 
 *    gcc -c sted_socket.c
 *
 * ѹ
 *   2005/02/01
 *     o sted.c  socket Υ롼ȴФ
 *   2005/03/27
 *     o Windows Ǥ⥳ѥ롦¹ԤǤ褦ѹ
 *   2005/05/14
 *     o EAGAIN  EWOULDBLOCK ѹ
 *     o Windows ΰ٤ sted_win.h  EWOULDBLOCK  define 褦ˤ
 *    
 *****************************************************************************/

#ifdef STE_WINDOWS
#include <windows.h>    /* for windows */
#include <WinSock2.h>   /* for windows */
#include <setupapi.h>   /* for windows */
#include <winioctl.h>   /* for windows */
#include <dbt.h>        /* for windows */
#else
#include <sys/socket.h>   
#include <netdb.h>        
#include <syslog.h>       
#include <sys/ethernet.h>
#include <sys/uio.h>
#endif
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "ste.h"
#include "sted.h"

#ifdef STE_WINDOWS
extern WSAEVENT   EventArray[2]; // socket  ste ɥ饤Ѥ 2 Ĥ Event 
#endif

extern int debuglevel;
extern int write_ste(stedstat_t *);

/*****************************************************************************
 * open_socket()
 * 
 * HUB(stehub)  TCP connection ΩSocket ֤
 * Proxy ФꤵƤС TCP connection Ω롣
 *
 *  
 *           stedstat: sted ѹ¤
 *           hub     : HUB Υۥ̾ʤȡ:פǤ줿ݡֹ
 *           proxy   : Proxy Υۥ̾ʤȡ:פǤ줿ݡֹ
 * ͡
 *          :  åֹ
 *         Ի :  -1
 *****************************************************************************/
int
open_socket(stedstat_t *stedstat, char *hub, char *proxy)
{
    static	struct  sockaddr_in sin;
    static	struct  hostent	   *hp;
    char *hub_name, *proxy_name;
    char *hub_port_string, *proxy_port_string;
    int hub_port, proxy_port;
    int   sock;
    char *temp;
    int nRtn;    

#ifdef STE_WINDOWS    
    WSADATA wsaData;
    nRtn = WSAStartup(MAKEWORD(1, 1), &wsaData);        
#endif

    memset((char *) &sin,0,sizeof(sin));
    if((hub_name = strtok(hub, ":")) == NULL){
        print_err(LOG_ERR, "hub name was not given\n");
        return(-1);
    }
    if((hub_port_string = strtok(NULL, ":")) == NULL){
        hub_port = PORT_NO;
    } else {
        hub_port = atoi(hub_port_string);
    }
    
    /*
     * stedstat ¤Τ hub Υۥ̾ݡֹϿ
     */
    strncpy(stedstat->hub_name, hub_name, MAXHOSTNAME);
    stedstat->hub_port = hub_port;

    if( proxy == NULL){
        /*
         * proxy ꤵƤʤΤǡľ ۥϥ֥ۥȤ³˹Ԥ
         * ˲ۥϥ֥ۥȤ hostent 롣
         */
        if(( hp = gethostbyname(hub_name)) == NULL) {
            print_err(LOG_ERR,"hostname %s not found.\n",hub_name);
            return(-1);
        }
        /*
         * sockaddr_in  sin_port  ۥϥ֥ۥȤΥݡֹ򥻥å
         */        
        sin.sin_port	= htons((short)hub_port);
        /*
         * stedstat ¤Τ proxy ˤ NULL 򥻥å
         */

        memset(stedstat->proxy_name, 0x0, MAXHOSTNAME);
        
        stedstat->proxy_port = 0;
    } else {
        /*
         * proxy ꤵƤΤǡproxy ³ˤɬפ롣
         * proxy Ф hostent 롣
         */
        if((proxy_name = strtok(proxy, ":")) == NULL){
            print_err(LOG_ERR,"proxy name was not given\n");
            return(-1);
        }
        if((proxy_port_string = strtok(NULL, ":")) == NULL){
            proxy_port = PORT_NO;
        } else {
            proxy_port = atoi(proxy_port_string);
        }
        if(( hp = gethostbyname(proxy_name)) == NULL) {
            print_err(LOG_ERR,"hostname %s not found.\n",proxy_name);
            return(-1);
        }
        /*
         * sockaddr_in  sin_port  proxy ФΥݡֹ򥻥å
         */
        sin.sin_port	= htons((short)proxy_port);
        /*
         * stedstat ¤Τ proxy ФΥۥ̾ݡֹϿ
         */
        strncpy(stedstat->proxy_name, proxy_name, MAXHOSTNAME);
        stedstat->proxy_port = proxy_port;
    }
    
    memcpy((char *)&sin.sin_addr,hp->h_addr,hp->h_length);
    sin.sin_family = AF_INET;

    if((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
        SET_ERRNO();
        print_err(LOG_ERR, "socket:%s\n", strerror(errno));
        return(-1);
    }

    if(connect(sock,(struct sockaddr *)&sin, sizeof sin) < 0) {
        SET_ERRNO();
        print_err(LOG_ERR, "connect: %s\n", strerror(errno));        
        return(-1);
    }

    /*
     * recv() ǥ֥åΤɤᡢnon-blocking mode 
     */      
#ifdef STE_WINDOWS
    if( WSAEventSelect(sock , EventArray[0] , FD_READ ) == SOCKET_ERROR ){
        SET_ERRNO();
        print_err(LOG_ERR,"WSAEventSelect failed: %s\n", strerror(errno));
        return(-1);
    }        
#else    
    if( fcntl(sock, F_SETFL, O_NONBLOCK) == -1) {
        SET_ERRNO();
        print_err(LOG_ERR, "Failed to set nonblock: %s\n",sock, strerror(errno));
        return(-1);
    }
#endif

    /*
     * stedstat ¤Τ FD Ͽ
     */
    stedstat->sock_fd = sock;

    /*
     * HUB ͳξCONNECT ꥯȤ
     */
    if(proxy != NULL){
        int stat;
        if((stat = send_connect_req(stedstat)) != 0){
            if ( stat > 0)
                print_err(LOG_ERR, "proxy server %s returned \"%d - %s\"\n",
                          proxy_name, stat, stat2string(stat));
            print_err(LOG_ERR, "CONNECT request to %s failed.\n",proxy_name);
            return(-1);
        }
    }
    print_err(LOG_NOTICE, "Successfully connected with HUB\n");
    
    return(sock);
}

/*****************************************************************************
 * read_socket()
 * 
 * HUB(stehub) Υǡɤ߹ߡ ste ɥ饤Фž롣
 *
 *  
 *           stedstat   : sted ѹ¤
 *           
 * ͡
 *           : recv() ɤ߹(0) ⤢롣
 *          㳲 :  -1
 *****************************************************************************/
int
read_socket(stedstat_t *stedstat)
{
    stehead_t   *steh;
    int          flags = 0;
    int          recvsize;  // recv() Ǽºݤɤ߹        
    int          cnt;       // recvsize ǡ̤Υǡ
    int          sock_fd = stedstat->sock_fd;
    u_char      *recvbuf = stedstat->recvbuf;
    u_char      *readp;
    u_char      *wdatabuf = stedstat->wdatabuf;

    if(debuglevel > 1){    
        print_err(LOG_DEBUG, "read_socket called\n");
    }
    
    if( (recvsize = recv(sock_fd, recvbuf, SOCKBUFSIZE,0)) < 0)  {
        SET_ERRNO();
        if(errno == EINTR || errno == EWOULDBLOCK || errno == 0){
            if(debuglevel > 1){
                print_err(LOG_NOTICE, "read_socket: recv %s\n", strerror(errno));
                print_err(LOG_DEBUG, "read_socket returned\n");
            }
            return(0);
        }        
        print_err(LOG_ERR,"read_socket: recv %s (%d)\n", strerror(errno),errno);
            if(debuglevel > 1){        
                print_err(LOG_DEBUG, "read_socket returned\n");
            }            
        return(-1);
    }
    if( recvsize == 0){
        print_err(LOG_ERR, "connection with hub is being closed\n");
        if(debuglevel > 1){                        
            print_err(LOG_DEBUG, "read_socket returned\n");
        }        
        return(-1);
    }
    
    if(debuglevel > 1){
        print_err(LOG_DEBUG, "========= from hub %d bytes ===================\n", recvsize);
        print_err(LOG_DEBUG, "datalen(Frame size)                   = %d\n", stedstat->datalen);        
        print_err(LOG_DEBUG, "dataleft(needed to complete Frame)    = %d\n",stedstat->dataleft);
        if (debuglevel > 2){
            int i;
            for (i = 0; i < recvsize; i++){
                if((i)%16 == 0){
                    print_err(LOG_DEBUG, "\n%04d: ", i);                    
                }
                print_err(LOG_DEBUG, "%02x ", recvbuf[i] & 0xff);                
            }
            print_err(LOG_DEBUG, "\n\n");
        }
    }

    /* ̤ǡ򥻥å */
    cnt = recvsize;
    /* ѤΥݥ󥿤򥻥å */
    readp = recvbuf;
            
    while(1){ 
        if (stedstat->dataleft == 0){
            /*
             * ǡƬʬƬʬ stehead ʤΤǡ
             * ɤ߹ǡե졼Υ롣
             */
            u_char *newp;
            if((newp = read_socket_header(stedstat, &cnt, readp)) == NULL){
                /* stehead ϤޤԴΥǡԤ */
                break;
            }
            readp = newp;
        }
        /*
         * ɤ߼ä stehead 顢ꥸʥ Ethernet ե졼Υ
         * ǧ 0 礭ETHERMAX(1514bytes)ʲǤ뤳ȤΤ롣
         */
        if( stedstat->orgdatalen <= 0 || stedstat->orgdatalen > ETHERMAX ){
            /*
             * stehead ϲƤȻפ롣ʹߤμǡ̵뤷롼פȴ롣
             * ʲۥϥ֤ѥåȤ򤳤ž˴ǽ⤤
             * ˡȡ̤ɤΥǡ򤹤٤˴뤷ʤޤμǡ
             * Ƭ stehead ǤȤݾڤ̵ᡢ٤ȡФ餯
             * ³ǽ롦إåϥǡζĽפʤ
             * ʤΤǡäȳμ¡˼ФȤߤƤɬפ롣
             */
            stedstat->dataleft = stedstat->datalen = stedstat->dummyheadlen = 0;
            print_err(LOG_NOTICE, "read_socket: header is broken\n");
            break;
        }
        if (debuglevel > 1) {
            print_err(LOG_DEBUG, "---------------------\n");                            
            print_err(LOG_DEBUG, "cnt(data size not yet processed)      = %d\n", cnt);
            print_err(LOG_DEBUG, "datalen(Frame size)                   = %d\n", stedstat->datalen);
            print_err(LOG_DEBUG, "dataleft(needed to complete Frame)    = %d\n", stedstat->dataleft);
        }
        if(cnt < stedstat->dataleft){
            /* μǡǤϸΥե졼ƹǤʤ */
            /* ȤꤢԡƤơΥǡԤ */
            /* 񤭹֤߰ϡ񤭹ߺѤߤΰ֤μ */
            memcpy(wdatabuf + (stedstat->datalen - stedstat->dataleft) , readp, cnt);
            stedstat->dataleft = stedstat->dataleft - cnt;
            if (debuglevel > 1) {
                print_err(LOG_DEBUG, "Need more %d bytes to complete a framed.\n", stedstat->dataleft);
            }            
            break;
        }
        if (cnt == stedstat->dataleft){
            /* μǡǸΥե졼ƹǤ */
            /* ٣ե졼ʬޤǤʤ */
            if (debuglevel > 1){
                print_err(LOG_DEBUG, "Frame completed. And no unread data left.\n");
            }
            memcpy(wdatabuf + (stedstat->datalen - stedstat->dataleft), readp, cnt);

            write_ste(stedstat);

            if (debuglevel > 1){
                print_err(LOG_DEBUG, "wrote %d bytes to driver completed.\n",stedstat->orgdatalen);
            }            
            stedstat->dataleft = stedstat->datalen = stedstat->dummyheadlen = 0;
            break;
        }
        if (cnt > stedstat->dataleft){
            /* μǡǸΥե졼ƹǤ */
            /* ̤Υե졼ΥǡޤޤƤ */
            memcpy(wdatabuf  + (stedstat->datalen - stedstat->dataleft), readp, stedstat->dataleft);
            write_ste(stedstat);            
            
            readp = readp + stedstat->dataleft;
            cnt = cnt - stedstat->dataleft;
            stedstat->dataleft = stedstat->datalen = stedstat->dummyheadlen = 0;
            if (debuglevel > 1){
                print_err(LOG_DEBUG, "Frame completed. Still %d bytes of unread data.\n", cnt);
                print_err(LOG_DEBUG, "wrote %d bytes to driver completed.\n",stedstat->orgdatalen);
            }
            /* while 롼פ³ */
            continue;
        }
    } /* while loop end */

    if(debuglevel > 1){                    
        print_err(LOG_DEBUG, "read_socket returned\n");
    }
    return(recvsize);
}

/*****************************************************************************
 * read_socket_header()
 * 
 * إåstehead ¤Ρˤɤ߼ꡢdummyhead ˥ԡ롣
 * äݥ󥿤˥إåΰʤϡʬ dummyhead
 * ˥ԡƤΥѥåȤԤġ
 *
 *  
 *           stedstat : sted ѹ¤
 *           cnt      : readp ˴ޤޤǡΥ
 *           readp    : ǡstehead ¤ΤޤȻפ
 * ͡
 *          stehead   : stehead ȤФǡɤ߹߳ϰ
 *          stehead ̤: NULL
 *****************************************************************************/
u_char *
read_socket_header(stedstat_t *stedstat, int *cnt, u_char *readp)
{
    int unreadlen; /* ޤ recv Ƥʤ header Ĺ */
    
    unreadlen = sizeof(stehead_t) - stedstat->dummyheadlen;
    
    if( *cnt >= unreadlen){
        /* stehead ­ʤȤ̵ */
        memcpy((char *)&stedstat->dummyhead + stedstat->dummyheadlen, readp, unreadlen);
        readp = readp + unreadlen;
        *cnt = *cnt - unreadlen;
        stedstat->dummyheadlen = sizeof(stehead_t);
        stedstat->datalen = stedstat->dataleft = ntohl(stedstat->dummyhead.len);
        stedstat->orgdatalen = ntohl(stedstat->dummyhead.orglen);
        if (debuglevel > 1) {
            print_err(LOG_DEBUG, "---------------------\n");            
            print_err(LOG_DEBUG, "read_socket_header: ste header is completed\n");
            print_err(LOG_DEBUG, "Data size = %d , Without PAD = %d\n",
                      stedstat->datalen, stedstat->orgdatalen);
        }
        return(readp);
    } else {
        /*
         * إåǤʤȤθ
         * ϤʤΤǡstehead 
         * ʬ夹ޤ recv 򷫤֤
         */
        memcpy((char *)&stedstat->dummyhead + stedstat->dummyheadlen, readp, *cnt);
        stedstat->dummyheadlen = stedstat->dummyheadlen + *cnt;
        if (debuglevel > 1) {
            print_err(LOG_DEBUG, "---------------------\n");            
            print_err(LOG_DEBUG, "read_socket_header: Insuficient header.\n");
        }
        return((u_char *)NULL);
    }
}

/*****************************************************************************
 * write_socket()
 * 
 * stedstat ¤Τ sendbuf ίޤäƤǡ HUB(stehub) ž롣
 *
 *  
 *           stedstat   : sted ѹ¤
 *           
 * ͡
 *           : 0
 *          㳲 : -1
 *****************************************************************************/
int
write_socket(stedstat_t *stedstat)
{
    if (debuglevel > 1) {        
        print_err(LOG_DEBUG,"write_socket called\n");
    }
    
    if( stedstat->sendbuflen == 0){
        if (debuglevel > 1) {
            print_err(LOG_ERR,"sendbuflen == 0\n");
            print_err(LOG_ERR,"write_socket returned\n");
        }
        return(0);
    }
    
    if ( send(stedstat->sock_fd, stedstat->sendbuf, stedstat->sendbuflen, 0) < 0){
        SET_ERRNO();
        if(errno == EINTR || errno == EWOULDBLOCK || errno == 0){
            if (debuglevel > 1) {            
                print_err(LOG_NOTICE, "write_socket: send: %s\n", strerror(errno));
            }                        
        } else {
            print_err(LOG_ERR,"write_socket: send %s (%d)\n", strerror(errno), errno);
            if (debuglevel > 1) {
                print_err(LOG_DEBUG,"write_socket returned\n");
            }            
            return(-1);
        }
    }
    stedstat->sendbuflen = 0;  /* 񤭹ߺѤߥ 0 ᤹ */
    if (debuglevel > 1) {                        
        print_err(LOG_DEBUG,"write_socket returned\n");
    }    
    return(0);
}

/*****************************************************************************
 * send_connect_req()
 * 
 * Proxy Ф CONNECT ꥯȤꤲ쥹ݥ󥹤Ԥġ
 * ⤷쥹ݥ󥹤Τʤˡ200(=OK)ޤޤƤʤä
 * Proxy Ф CONNECT ᥽åɤ򥵥ݡȤƤʤʤ⤷
 * ȥȤˤȻפ롣 -1 ֤
 *
 *  
 *           stedstat : sted ѹ¤
 * ͡
 *           : Proxy Ф֤äƤơ
 *          㳲 : -1
 *****************************************************************************/
int
send_connect_req(stedstat_t *stedstat)
{
    static fd_set fds;
    struct timeval timeout;
    int ret, cnt;
    u_char buf[SOCKBUFSIZE];
    char *http_ver;       /* 쥹ݥ󥹤˴ޤޤ HTTP С */
    char *http_stat_char; /* 쥹ݥ󥹤˴ޤޤ ơ */
    int  http_stat;       /* 쥹ݥ󥹤˴ޤޤ ơ */
    char connect_req[CONNECT_REQ_SIZE];
    char *hub_name = stedstat->hub_name;
    int hub_port = stedstat->hub_port;
    int  sock = stedstat->sock_fd;
        
    timeout.tv_sec = CONNECT_REQ_TIMEOUT;
    timeout.tv_usec = 0;

    FD_ZERO(&fds);
    FD_SET(sock, &fds);
        
    sprintf(connect_req, 
             "CONNECT %s:%d HTTP/1.1\r\nHost: %s:%d\r\n\r\n",
             hub_name, hub_port, hub_name, hub_port);
    if ( send(sock, connect_req , strlen(connect_req), 0) < 0){
        /* λǤƤ error  error Ȥƽλ */
        SET_ERRNO();
        print_err(LOG_ERR, "send_connect_req: send %s (%d)\n", strerror(errno), errno);
        return(-1);
    }
    ret = select(sock+1, &fds, NULL, NULL, &timeout);
    if( ret = 0){
        SET_ERRNO();    
        print_err(LOG_ERR,"send_connect_req: select %s\n", strerror(errno));
        return(-1);
    } else if(ret < 0){
        SET_ERRNO();            
        print_err(LOG_ERR,"send_connect_req: select %s\n", strerror(errno));            
        return(-1);
    }

    if(FD_ISSET(sock, &fds)) {
        if( (cnt = recv(sock, buf, SOCKBUFSIZE,0)) < 0)  {
            SET_ERRNO();
            if(errno == EINTR || errno == EWOULDBLOCK || errno == 0){
                if(debuglevel > 1){                    
                    print_err(LOG_NOTICE, "send_connect_req: recv %s\n", strerror(errno));
                }
                return(0);
            }
            print_err(LOG_ERR,"send_connect_req: recv %s (%d)\n", strerror(errno), errno);
            return(-1);
        }
        if( cnt == 0){
            print_err(LOG_ERR, "connection with proxy server is being closed\n");
            return(-1);
        }
        /*
         * ǡ HTTP ơ饤ޤǤƴޤޤƤʤ⤷
         * ʤCRLF θˡ¾βۥϥ֤Υǡ⤦ޤޤƤ뤫
         * ʤǤϤ̵뤹롣
         * ʤǤϥǡߤ褦ʤΤǡ
         */
        if((http_ver = strtok((char *)buf, " ")) == NULL){
            print_err(LOG_ERR, "send_connect_req: Illegal responce from Proxy server\n");
            return(-1);
        }
        if((http_stat_char = strtok(NULL, " "))  == NULL){
            print_err(LOG_ERR, "send_connect_req: Illegal responce from Proxy server\n");
            return(-1);
        }
        http_stat = atoi(http_stat_char);
        /*
         * Proxy ֤줿ơɤ return 
         */
        if( http_stat != HTTP_STAT_OK){
            return(http_stat);
        }
        return(0);
    }
    /* ꤨʤȻפ */
    return(-1);
}

/*****************************************************************************
 * stat2string()
 *
 * Proxy ֤줿ơɤûʬ֤(RFC 2616 )
 * ơ饤ˤޤޤƤϤǲ褹뤳Ȥˤ
 * ޤ̵̣
 *
 *  
 *           stat : proxy Ф֤ä褿ơ
 * ͡
 *          ơɤбʸؤΥݥ
 *****************************************************************************/
char *
stat2string(int stat)
{
    static char desc[50];
    switch(stat){
        case 100 :
            strcpy(desc, "Continue");
            break;                                 
        case 101 :
            strcpy(desc, "Switching Protocols");
            break;                       
        case 200 :
            strcpy(desc, "OK");
            break;                                        
        case 201 :
            strcpy(desc, "Created");
            break;                                   
        case 202 :
            strcpy(desc, "Accepted");
            break;                                  
        case 203 :
            strcpy(desc, "Non-Authoritative Information");
            break;             
        case 204 :
            strcpy(desc, "No Content");
            break;                                
        case 205 :
            strcpy(desc, "Reset Content");
            break;                             
        case 206 :
            strcpy(desc, "Partial Content");
            break;                           
        case 300 :
            strcpy(desc, "Multiple Choices");
            break;                          
        case 301 :
            strcpy(desc, "Moved Permanently");
            break;                         
        case 302 :
            strcpy(desc, "Found");
            break;                                     
        case 303 :
            strcpy(desc, "See Other");
            break;                                 
        case 304 :
            strcpy(desc, "Not Modified");
            break;                              
        case 305 :
            strcpy(desc, "Use Proxy");
            break;                                 
        case 307 :
            strcpy(desc, "Temporary Redirect");
            break;                        
        case 400 :
            strcpy(desc, "Bad Request");
            break;                               
        case 401 :
            strcpy(desc, "Unauthorized");
            break;                              
        case 402 :
            strcpy(desc, "Payment Required");
            break;                          
        case 403 :
            strcpy(desc, "Forbidden");
            break;                                 
        case 404 :
            strcpy(desc, "Not Found");
            break;                                 
        case 405 :
            strcpy(desc, "Method Not Allowed");
            break;                        
        case 406 :
            strcpy(desc, "Not Acceptable");
            break;                            
        case 407 :
            strcpy(desc, "Proxy Authentication Required");
            break;             
        case 408 :
            strcpy(desc, "Request Time-out");
            break;                          
        case 409 :
            strcpy(desc, "Conflict");
            break;                                  
        case 410 :
            strcpy(desc, "Gone");
            break;                                      
        case 411 :
            strcpy(desc, "Length Required");
            break;                           
        case 412 :
            strcpy(desc, "Precondition Failed");
            break;                       
        case 413 :
            strcpy(desc, "Request Entity Too Large");
            break;                  
        case 414 :
            strcpy(desc, "Request-URI Too Large");
            break;                     
        case 415 :
            strcpy(desc, "Unsupported Media Type");
            break;                    
        case 416 :
            strcpy(desc, "Requested range not satisfiable");
            break;           
        case 417 :
            strcpy(desc, "Expectation Failed");
            break;                        
        case 500 :
            strcpy(desc, "Internal Server Error");
            break;                     
        case 501 :
            strcpy(desc, "Not Implemented");
            break;                           
        case 502 :
            strcpy(desc, "Bad Gateway");
            break;                               
        case 503 :
            strcpy(desc, "Service Unavailable");
            break;                       
        case 504 :
            strcpy(desc, "Gateway Time-out");
            break;                          
        case 505 :
            strcpy(desc, "HTTP Version not supported");
            break;
        default:
            strcpy(desc, "Unknown Code");
            break;
    }
    return(desc);
}

