/**********************************************************
 * stehub.c
 *
 * $Date: 2006/04/04 15:46:14 $, $Revision: 1.8 $
 *
 * ۥϥ֡ NIC ǡ󤫤 Ethernet ե졼ꡢ
 * ¾β NIC ǡžĥ桼ץ
 *
 *  gcc stehub.c -o stehub -lsocket -lnsl
 *
 * Usage: stehub [ -p port] [-d level]
 *
 *     :
 *        -p port   NIC ǡ󤫤³Ԥݡֹꤹ롣
 *                 ꤵʤСǥեȤ 80 Ȥ롣
 *
 * ѹ :
 *    o recv()  Хåե 500byte  32K bytes ѹ
 *    o listen() ݡֹư˻Ǥ褦ˤ
 *  2004/12/15
 *    o ä conn_stat ¤Τ fee() Ƥޤ
 *  2004/12/18
 *   o debug ץɲä
 *   o debug ٥뤬 0 (ǥեȡˤξϡХå饦ɤ
 *     ¹Ԥ褦ˤ
 *   o debug ٥뤬 0 (ǥեȡˤξϡƼ泌顼å
 *      syslog ˽Ф褦ˤ
 *  2004/12/29
 *   o include եɲ
 *  2004/12/30
 *   o LinuxǤ⥳ѥǤ褦 include եɲ
 *   o SFU 3.5 򥤥󥹥ȡ뤷 Windows Ǥ⥳ѥ롢¹ԤǤ褦
 *     ¿ѹԤä
 *  2005/01/08
 *   o send() Υ顼ǧ褦ˤEWOULDBLOCKEINTR ξ̵뤹褦ˤ
 *  2005/01/09
 *   o send() Υ顼ְäƤΤǽ
 *  2005/03/27
 *   o Windows ǤѲǽʤ褦˽ʤޤ̤ѡ
 *   o recv() Υ顼ְäƤΤǽ
 * 
 ***********************************************************/

#ifdef STE_WINDOWS
#include <winsock2.h>   /* for windows */
#include <Windows.h>    /* for windows */
#include <time.h>       /* for windows */
#include <winioctl.h>   /* for windows */
#include <setupapi.h>   /* for windows */
#include <dbt.h>        /* for windows */
#include <direct.h>
#include "getopt_win.h"
#else 
#define  WINAPIV        /* for solaris */
#include <strings.h>    /* for solaris */
#include <unistd.h>     /* for solaris */
#include <sys/socket.h> /* for solaris */
#include <netinet/in.h> /* for solaris */
#include <netdb.h>      /* for solaris */
#include <syslog.h>     /* for solaris */
#include <libgen.h>     /* for solaris */
#include <arpa/inet.h>  /* for solaris */
#include <sys/time.h>   /* for solaris */
#endif
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>
#include <stdarg.h> 
#include <sys/stat.h>
#include <fcntl.h>
#include "sted.h"

#define PORT_NO        80     /* ³ԤǥեȤΥݡֹ */
#define SOCKBUFSIZE    32768  /* recv(), send() ѤΥХåեΥ  */

#ifdef  FD_SETSIZE
#undef  FD_SETSIZE
#endif
#define FD_SETSIZE     1024


#ifdef  STE_WINDOWS
HANDLE  hStedLog;          /* ǥХåѤΥեϥɥ */
#define STEHUB_LOG_FILE   "C:\\stehub.log" /* ե */
#endif

struct conn_stat {
    struct conn_stat *next;
    int fd;
    struct in_addr addr;
};

void  add_conn_stat(int, struct in_addr);
void  delete_conn_stat(int);
struct conn_stat *find_conn_stat(int);
int   become_daemon();
void  print_err(int, char *, ...);
void  print_usage(char *);
extern char *basename(char *); /* for Interix */

struct conn_stat   conn_stat_head[1];
int           use_log = 0;      /* å STDERR Ǥʤsyslog ˽Ϥ */
static int    debuglevel = 0;   /* ǥХå٥롣 1 ʾʤե饦ɤǼ¹ */
extern char  *optarg;
extern int    optind;
extern int    optopt;
extern int    opterr;
extern int    optreset;

int WINAPIV
main(int argc,char *argv[])
{
    int                 listener_fd, new_fd;
    int                 remotelen;
    int                 port = 0;
    int                 c, on;
    struct sockaddr_in  local_sin, remote_sin;
    static              fd_set  fdset, fdset_saved;
    struct conn_stat   *rconn, *wconn;
#ifdef STE_WINDOWS
    u_long              param = 0; /* FIONBIO ޥɤΥѥ᡼ Non-Blocking ON*/
    int                 nRtn;
    WSADATA             wsaData;
    nRtn = WSAStartup(MAKEWORD(1, 1), &wsaData);        
#endif

    while ((c = getopt(argc, argv, "p:d:")) != EOF){
        switch (c) {
            case 'p':
                port = atoi(optarg);
                break;                
            case 'd':
                debuglevel = atoi(optarg);
                break;
            default:
                print_usage(argv[0]);
        }
    }    

    conn_stat_head->next = NULL;
    conn_stat_head->fd = 0;

    if(( listener_fd = socket( AF_INET, SOCK_STREAM,0 )) < 0 ) {
        SET_ERRNO();
        print_err(LOG_ERR,"socket: %s (%d)\n", strerror(errno), errno);
        exit(1);
    }

    on = 1;
    if((setsockopt(listener_fd, SOL_SOCKET, SO_REUSEADDR, (char *)&on, sizeof(on))) <0){
        SET_ERRNO();        
        print_err(LOG_ERR,"setsockopt:%s\n", strerror(errno));                
        exit(1);
    }

    if(port == 0)
        port = PORT_NO;
    memset((char *)&remote_sin, 0x0, sizeof(struct sockaddr_in));
    memset((char *)&local_sin, 0x0, sizeof(struct sockaddr_in));
    local_sin.sin_port   = htons((short)port);
    local_sin.sin_family = AF_INET;
    local_sin.sin_addr.s_addr = htonl(INADDR_ANY);

    if(bind(listener_fd,(struct sockaddr *)&local_sin,sizeof(struct sockaddr_in)) < 0 ){
        SET_ERRNO();
        print_err(LOG_ERR,"bind:%s\n", strerror(errno));                        
        exit(1);
    }


    /*
     * accept() ǥ֥åΤɤᡢnon-blocking mode 
     */
#ifndef STE_WINDOWS            
    if( fcntl (listener_fd, F_SETFL, O_NONBLOCK) < 0) {
#else
    if( ioctlsocket(listener_fd, FIONBIO, &param) < 0){
#endif                
        SET_ERRNO();
        print_err(LOG_ERR, "Failed to set nonblock: %s (%d)\n",strerror(errno), errno);
        exit(1);
    }

    if(listen(listener_fd, 5) < 0) {
        SET_ERRNO();
        print_err(LOG_ERR,"listen:%s\n", strerror(errno));                                
        exit(1);
    }

    FD_ZERO(&fdset_saved);
    FD_SET(listener_fd, &fdset_saved);

    /*
     * syslog ΤꡣFacility ϡLOG_USER Ȥ
     * Windows ξϥե򥪡ץ󤹤롣
     */
#ifdef STE_WINDOWS
    hStedLog = CreateFile(STEHUB_LOG_FILE,
                          GENERIC_READ|GENERIC_WRITE,
                          FILE_SHARE_READ| FILE_SHARE_WRITE,
                          NULL,
                          CREATE_ALWAYS,
                          FILE_ATTRIBUTE_NORMAL,
                          NULL);
    SetFilePointer(hStedLog, 0, NULL, FILE_END);
#else
     openlog(basename(argv[0]),LOG_PID,LOG_USER);
#endif
     
    /*
     * ޤǤϤȤꤢե饦ɤǼ¹ԡ
     * ϡǥХå٥ 0 ʥǥեȡˤʤ顢Хå饦
     * Ǽ¹ԤǤʤХե饦³ԡ
     * Windows ξϡŤˤƤե饦ɤǼ¹
     * ǥХå٥ 1 ʾξϥե˽񤯡
     */
    if (debuglevel == 0){
#ifndef STE_WINDOWS             
        print_err(LOG_NOTICE,"Going to background mode\n");
        if(become_daemon() != 0){
            print_err(LOG_ERR,"can't become daemon\n");
            print_err(LOG_ERR,"Exit\n");            
            exit(1);
        }
#else 
        use_log = 1;
#endif    
    }
    print_err(LOG_NOTICE,"Started\n");        

    /*
     * ᥤ롼
     *  NIC ǡ󤫤³׵Ԥ³ϲ NIC ǡ
     * ΥǡԤġĤβۥǡ󤫤Υǡ¾ž롣
     */
    for(;;){
        fdset = fdset_saved;
        if( select(FD_SETSIZE, &fdset, NULL, NULL, NULL) < 0){
            SET_ERRNO();
            print_err(LOG_ERR,"select:%s\n", strerror(errno));
        }

        if(FD_ISSET(listener_fd, &fdset)){
            remotelen = sizeof(struct sockaddr_in);
            if((new_fd = accept(listener_fd,(struct sockaddr *)&remote_sin, &remotelen)) < 0){
                SET_ERRNO();
                if(errno == EINTR || errno == EWOULDBLOCK || errno == ECONNABORTED){
                    print_err(LOG_NOTICE, "accept: %s\n", strerror(errno));
                    continue;
                } else {
                    print_err(LOG_ERR, "accept: %s\n", strerror(errno));                    
                    return(-1);
                }
            }
            
            FD_SET(new_fd, &fdset_saved);
            print_err(LOG_NOTICE,"fd%d: connection from %s\n",new_fd, inet_ntoa(remote_sin.sin_addr));
            add_conn_stat(new_fd, remote_sin.sin_addr);
            /*
             * recv() ǥ֥åΤɤᡢnon-blocking mode 
             */
#ifndef STE_WINDOWS            
            if (fcntl(new_fd, F_SETFL, O_NONBLOCK) < 0 ) {
#else
                if(ioctlsocket(new_fd, FIONBIO, &param) < 0){
#endif                
                    SET_ERRNO();
                    print_err(LOG_ERR, "fd%d: Failed to set nonblock: %s (%d)\n",
                              new_fd,strerror(errno),errno);
                    return(-1);
                }
                continue;
            }

            for( rconn = conn_stat_head->next ; rconn != NULL ; rconn = rconn->next){
                int rfd, wfd;

                rfd = rconn->fd;
            
                if (FD_ISSET(rfd, &fdset)){
                    int   rsize;
                    char  databuf[SOCKBUFSIZE];
                    char *bufp;
                    int   datalen;

                    bufp = (char *)databuf;
                    rsize = recv(rfd, bufp, SOCKBUFSIZE,0);
                    if(rsize == 0){
                        /*
                         * ͥǤ줿褦
                         * socket  close ƥ롼פȴ
                         */
                        print_err(LOG_ERR,"fd%d: Connection closed by %s\n", rfd, inet_ntoa(rconn->addr));
                        CLOSE(rfd);
                        print_err(LOG_ERR,"fd%d: closed\n", rfd);
                        FD_CLR(rfd, &fdset_saved);
                        delete_conn_stat(rfd);
                        break;
                    }
                    if(rsize < 0){
                        SET_ERRNO();                    
                        /*
                         * ̿ŪǤʤ error ξ̵뤷ƥ롼פ³
                         */
                        if(errno == EINTR || errno == EWOULDBLOCK){
                            print_err(LOG_NOTICE, "fd%d: recv: %s\n", rfd, strerror(errno));
                            continue;
                        }
                        /*
                         * 顼ȯ褦
                         * socket  close  for롼פȴ
                         */
                        print_err(LOG_ERR,"fd%d: recv: %s\n", rfd,strerror(errno));
                        CLOSE(rfd);
                        print_err(LOG_ERR,"fd%d: closed\n", rfd);
                        FD_CLR(rfd, &fdset_saved);
                        delete_conn_stat(rfd);
                        break;
                    }
                    /*
                     * ¾β NIC ˥ѥåȤž롣
                     * Ԥפȯȡѥեޥ󥹤˱ƶΤǡEWOULDBLOCK
                     *  ξ򤢤롣
                     */
                    for(wconn = conn_stat_head->next ; wconn != NULL ; wconn = wconn->next){
                    
                        wfd = wconn->fd;

                        if (rfd == wfd)
                            continue;

                        if( debuglevel > 1){
                            print_err(LOG_ERR,"fd%d(%s) ==> ", rfd, inet_ntoa(rconn->addr));
                            print_err(LOG_ERR,"fd%d(%s)\n", wfd,inet_ntoa(wconn->addr));
                        }
                
                        if ( send(wfd, bufp, rsize, 0) < 0){
                            SET_ERRNO();                    
                            if(errno == EINTR || errno == EWOULDBLOCK ){
                                print_err(LOG_NOTICE,"fd%d: send: %s\n", wfd ,strerror(errno));
                                continue;
                            } else {
                                print_err(LOG_ERR,"fd%d: send: %s (%d)\n",wfd,strerror(errno), errno);
                                CLOSE(wfd);
                                print_err(LOG_ERR,"fd%d: closed\n", wfd);
                                FD_CLR(wfd, &fdset_saved);
                                delete_conn_stat(wfd);
                                break;                            
                            }
                        }                    
                    } /* End of loop for send()ing */
                }
            } /* End of loop for each connection */
        } /* End of main loop */
}

/*****************************************************************************
 * add_conn_stat()
 *
 * conn_stat ¤ΤΥ󥯥ꥹȤ˿ conn_stat ɲä롣
 *
 *  
 *          fd: ͥ socket ֹ
 *          addr: ³ƤۥȤΥɥ쥹
 * ͡
 *          ̵
 *****************************************************************************/
void
add_conn_stat(int fd, struct in_addr addr)
{
    struct conn_stat *conn, *conn_stat_new;

    int i = 0;
    
    for( conn = conn_stat_head ; conn->next != NULL ; conn = conn->next);
    
    conn_stat_new = (struct conn_stat *)malloc(sizeof(struct conn_stat));
    conn_stat_new->fd = fd;
    conn_stat_new->addr = addr;
    conn_stat_new->next = NULL;

    conn->next = conn_stat_new;
}

/*****************************************************************************
 * delete_conn_stat()
 *
 * conn_stat ¤ΤΥ󥯥ꥹȤꤵ줿 conn_stat 
 *
 *  
 *          fd:  conn_stat ¤Τ˴ޤޤ socket ֹ
 *  ͡
 *          ̵
 *****************************************************************************/
void
delete_conn_stat(int fd)
{
    struct conn_stat *conn, *conn_stat_delete;
    int i = 0;

    conn = conn_stat_head;

    while( conn != NULL){
        if(conn->next->fd == fd){
            conn_stat_delete = conn->next;
            conn->next = conn_stat_delete->next;
            free(conn_stat_delete);
            return;
        }
        conn = conn->next;
    }
}
/*****************************************************************************
 * find_conn_stat()
 *
 * fd ˤäƻꤵ줿 conn_stat ¤ΤΤõreturn 롣
 *
 *  
 *          fd:  conn_stat ¤Τ˴ޤޤ socket ֹ
 *  ͡
 *          conn_stat ¤ΤΥݥ
 *****************************************************************************/
struct conn_stat *
find_conn_stat(int fd)
{
    struct conn_stat *conn;
    int i = 0;

    conn = conn_stat_head;

    while( conn != NULL){
        if(conn->next->fd == fd){
            return(conn->next);
        }
        conn = conn->next;
    }
    return((struct conn_stat *)NULL);
}

#ifndef STE_WINDOWS
/*****************************************************************************
 * become_daemon()
 * 
 * ɸϡɸ२顼Ϥ򥯥Хå饦ɤ˰ܹԤ롣
 *****************************************************************************/
int
become_daemon()
{
    chdir("/");
    umask(0);
    signal(SIGHUP,SIG_IGN);

    if( fork() == 0){
        use_log = 1;
        close (0);
        close (1);
        close (2);
        /* åγ */
        if (setsid() < 0)
            return(-1);
    } else {
        exit(0);
    }
    return(0);
}
#endif

/***********************************************************
 * print_err()
 *
 * 顼åɽ롼
 * 
 ***********************************************************/
void
print_err(int level, char *format, ...)
{
    va_list ap;
    char buf[ERR_MSG_MAX];
    int length;    
    
    va_start(ap, format);
    vsprintf(buf, format, ap);
    va_end(ap);

    if(use_log){
#ifdef STE_WINDOWS
        WriteFile(hStedLog, buf, strlen(buf), &length, NULL);
#else    
        syslog(level, buf);
#endif            
    } else {
        fprintf(stderr, buf);
    }
}
/*****************************************************************************
 * print_usage()
 * 
 * Usage ɽλ롣
 *****************************************************************************/
void
print_usage(char *argv)
{
    printf ("Usage: %s [ -p port] [-d level]\n",argv);    
    printf ("\t-p port   : Port nubmer\n");
    printf ("\t-d level  : Debug level[0-2]\n");
    exit(0);
}
